function [M,M_tr]=tl_adj(dt,sigma,beta,rho,future_f)

%--------------------------------------
% adjoint of the lorenz 63 model with a modified Euler scheme
%
% A. Fowler
%--------------------------------------

x=future_f(1);
y=future_f(2);
z=future_f(3);

%firstly calc df1
dx1=dt*sigma*(y-x);
dy1=dt*(x*(rho-z)-y);
dz1=dt*(x*y-beta*z);

%-----------

% define A=(M_1') 
A(1,1)=-dt*sigma;
A(2,1)=dt*(rho-z);
A(3,1)=dt*(y);
A(1,2)=dt*sigma;
A(2,2)=-dt;
A(3,2)=dt*(x);
A(1,3)=0;
A(2,3)=-dt*(x);
A(3,3)=-dt*beta;

% define B=M_half' (transform from f_hat_half to 2*f_hat_1)
B(1,1)=-dt*sigma;
B(2,1)=dt*(rho-(z+dz1));
B(3,1)=dt*(y+dy1);
B(1,2)=dt*sigma;
B(2,2)=-dt;
B(3,2)=dt*(x+dx1);
B(1,3)=0;
B(2,3)=-dt*(x+dx1);
B(3,3)=-dt*beta;

%
Id=eye(3);

M=Id+0.5*(B*(A+Id)+A);
M_tr=M';

